%genHor
%this randomly generates a Timhorizon to initially score the strategies on.
%Here, the histories and subsequent winning decisions will be given
%explicitly although only the bitstring of the T+m last outcomes is
%actually required.


%set m1 agents'

timeHorizonHistories1= zeros(T1,1);
timehorizonWinningOutcomes1 = zeros(T1,1);

%need an initial history
%this is an integer number between 0 and 2^m - 1
%vorrespnding to a binary string length m
initHist= (2^m1)*rand(1);
timeHorizonHistories1(1)= initHist -rem(initHist,1);
%and a subsequent random winning decision!!
binVal = 2*rand(1);
timehorizonWinningOutcomes1(1) = binVal-rem(binVal,1);

%generate the rest of the time-horizon randomly
for i = 2:T1
    %update the history
    newHist =timeHorizonHistories1(i-1);
    newHist =bitset(newHist,m1,0);                       %get rid of most signifcant bit
    newHist =bitshift(newHist,1);                         %move it over one
    newHist =bitset(newHist,1,timehorizonWinningOutcomes1(i-1)); %and update
    timeHorizonHistories1(i) = newHist;
    %subsequent winning decision;
    binVal = 2*rand(1);
    timehorizonWinningOutcomes1(i) = binVal-rem(binVal,1);
end


%set the current history
 history1 = timeHorizonHistories1(T1);
   history1 =bitset(history1,m1,0);                       %get rid of most signifcant bit
    history1 =bitshift(history1,1);                         %move it over one
    history1 =bitset(history1,1,timehorizonWinningOutcomes1(T1));

%set m2 agents'    
    
timeHorizonHistories2= zeros(T2,1);
timehorizonWinningOutcomes2 = zeros(T2,1);

%need an initial history
%this is an integer number between 0 and 2^m - 1
%vorrespnding to a binary string length m
initHist= (2^m2)*rand(1);
timeHorizonHistories2(1)= initHist -rem(initHist,1);
%and a subsequent random winning decision!!
binVal = 2*rand(1);
timehorizonWinningOutcomes2(1) = binVal-rem(binVal,1);

%generate the rest of the time-horizon randomly
for i = 2:T2
    %update the history
    newHist =timeHorizonHistories2(i-1);
    newHist =bitset(newHist,m2,0);                       %get rid of most signifcant bit
    newHist =bitshift(newHist,1);                         %move it over one
    newHist =bitset(newHist,1,timehorizonWinningOutcomes2(i-1)); %and update
    timeHorizonHistories2(i) = newHist;
    %subsequent winning decision;
    binVal = 2*rand(1);
    timehorizonWinningOutcomes2(i) = binVal-rem(binVal,1);
end


%set the current history
 history2 = timeHorizonHistories2(T2);
   history2 =bitset(history2,m2,0);                       %get rid of most signifcant bit
    history2 =bitshift(history2,1);                         %move it over one
    history2 =bitset(history2,1,timehorizonWinningOutcomes2(T2));

