%genScores
%generates the strategy scores.
    %this could be done more efficiently by only considering the changes
    %caused by the start of the timehorizon being neglected and the end of
    %the timehorizon appearing. i.e. not recalculating for the whole length
    %of the rolling window.
    
    
% one way of doing this is for each agent you go through each strategy and
% then through the timehorizon which is a fairly long winded way of doing
% things.

%here, we can use a time-horizon impact vector which appears just like a strategy 
%in that it is a vector length 2^m . If a particular history has been
%visited a number of times, the aggregate resulte populates the element in
%the vector corresponding to the history. So if it has visited history 8 5
%times within the rolling window, and subsequently the winning decision
%has been two 1s and 3 zeros, a -1 would fill position 8 in this vector.

%by doing this, the score of  any strategy is merely the strategy itself converted to +-1,
%dot-producted with this impact vector.

%calculate m1 agents'

impactVector1 = zeros((2^m1),1); 

for i =1:T1;
 impactVector1(timeHorizonHistories1(i)+1) = impactVector1(timeHorizonHistories1(i)+1)+(2*timehorizonWinningOutcomes1(i))-1;   %add +1 if w.d. is 1 add -1 if subsequent winning decision=0;
end


%go through agents and update the scores
%strategyScores = zeros(N,s);
%strategies = zeros(N,s,(2^m));
strat1 = zeros(2^m1,1);
for i = 1:N1;
    for j =1:s
        
        strat1(:) = strategies1(i,j,:);
        strat1 = (2*strat1-1);
        strategyScores1(i,j) = dot(strat1,impactVector1);
        
    end
end

%calculate m2 agents'

impactVector2 = zeros((2^m2),1);

for i =1:T2;
    impactVector2(timeHorizonHistories2(i)+1) = impactVector2(timeHorizonHistories2(i)+1)+...
       (2*timehorizonWinningOutcomes2(i))-1;   %add +1 if w.d. is 1 add -1 if subsequent winning decision=0;
end


%go through agents and update the scores
%strategyScores = zeros(N,s);
%strategies = zeros(N,s,(2^m));
strat2 = zeros(2^m2,1);
for i = 1:N2;
    for j =1:s
        
        strat2(:) = strategies2(i,j,:);
        strat2 = (2*strat2-1);
        strategyScores2(i,j) = dot(strat2,impactVector2);
        
    end
end