%generates and runs a simple mix-game!!


close all
clear all
 

%first set the parameters
m1 = 3;  m2 =6; %memory size

s = 2;   %number of strategies
N = 201; N1 =40; N2 = N - N1;%number of agents
T1 = 12; T2 =60; %time-window over which the strategies are scored
L = 0.5; %resource as fraction of the population (number who can be rewarded)
 
t = 5; %time-window for calculating volatility of price fluctuation
simduration = 500;


%generate a QDM
genQDM


%generate a random inital state!genHor

genHor

%play the game

 
priceSeries = zeros(simduration,1);
price=0;

volatility=zeros(simduration,1);
IncrPriceSeries=zeros(t,1);

returnPrice=zeros(simduration-1,1);


winAgentScoresR1=zeros(N1,1);
StratvScore1=zeros(N1,s);
winAgentScoresR2=zeros(N2,1);
StratvScore2=zeros(N2,s);
 StratvScoreSeries1=zeros(N1,s,simduration);   StratvScoreSeries2=zeros(N2,s,simduration); 

  
for currentTime = 1:simduration
    
    genScores 
   
    
    genDecisions
    
    %increment the price
    price = price+numOnes-numZeros;
    priceSeries(currentTime)=price;
    
    %get the winning decision
     %for agents with m1, who play majority game
        if(numOnes>(N*L)) winningDecision1=1; end  
        if(numOnes<(N*L)) winningDecision1=0; end
        if(numOnes==(N*L)) 
            binVal = 2*rand(1);
            winningDecision1 = binVal-rem(binVal,1);
        end
     %for agents with m2, who play minority game
        if(numOnes<(N*L)) winningDecision2=1; end
        if(numOnes>(N*L)) winningDecision2=0; end
        if(numOnes==(N*L)) 
            binVal = 2*rand(1);
            winningDecision2 = binVal-rem(binVal,1);
        end
      %calculate the winning scores of agents
        winScore2
          
 
    %update the time horizon
    
    %for agents with m1
    for i= 1:(T1-1)
        timeHorizonHistories1(i)= timeHorizonHistories1(i+1);
        timehorizonWinningOutcomes1(i) = timehorizonWinningOutcomes1(i+1);
    end
    timeHorizonHistories1(T1)=  history1;
    timehorizonWinningOutcomes1(T1)= winningDecision1;
    
    %set the next history
    history1 = timeHorizonHistories1(T1);
    history1 =bitset(history1,m1,0);                       %get rid of most signifcant bit
    history1 =bitshift(history1,1);                         %move it over one
    history1 =bitset(history1,1,timehorizonWinningOutcomes1(T1));
    
    % agents with m2
   for i= 1:(T2-1)
        timeHorizonHistories2(i)= timeHorizonHistories2(i+1);
        timehorizonWinningOutcomes2(i) = timehorizonWinningOutcomes2(i+1);
    end
    timeHorizonHistories2(T2)= history2;
    timehorizonWinningOutcomes2(T2)= winningDecision2;
    %set the next history
    history2 = timeHorizonHistories2(T2);
    history2 =bitset(history2,m2,0);                       %get rid of most signifcant bit
    history2 =bitshift(history2,1);                         %move it over one
    history2 =bitset(history2,1, timehorizonWinningOutcomes2(T2));
    
    
 %calculating local volatility with time-window t and calculate returns
	
	if currentTime >1
		IncrPrice=priceSeries(currentTime)-priceSeries(currentTime-1);
        for i=1:t-1
            IncrPriceSeries(i)=IncrPriceSeries(i+1);
        end  
        IncrPriceSeries(t)=IncrPrice;
        volatility(currentTime)=std(IncrPriceSeries)*std(IncrPriceSeries);
        %calculate returns
       if priceSeries(currentTime-1)~=0
          returnPrice(currentTime)=IncrPrice/priceSeries(currentTime-1);
          returnPriceAbs(currentTime)= abs(returnPrice(currentTime));
        
       else
       end
       
	else
	end

end
 
%plot the series,
figure(1)

subplot(2,1,1); plot(1:simduration,priceSeries);
xlabel('time'); ylabel('price');

subplot(2,1,2); plot(1:simduration,volatility)
xlabel('time'); ylabel('volatility');
title('m1=3, m2=6, T1=36, T2=6, N=201, N1=72, s=2');

figure(2)
plot(1:simduration,returnPrice);
xlabel('time'); ylabel('price return');
title('m1=6, m2=6, T1=60, T2=60, N=201, N1=40');

figure(3)
x = -3:0.001:3;
hist(returnPrice,x)
xlabel('price return'); ylabel('number of return');
title('m1=6, m2=6, T1=60, T2=60, N=201, N1=40');

figure(4)
x = 0:0.001:70;
hist(returnPriceAbs,x);
xlabel('absolute return'); ylabel('number of absolute return');
title('m1=3, m2=6, T1=36, T2=6, N=201, N1=72, s=2');

fig

meanScore2

autocorrelation